//+------------------------------------------------------------------+
//
// Bookkeeper:    :
//+------------------------------------------------------------------+
//|                                         Waddah_Attar_Def_RSI.mq4 |
//|                              Copyright  2007, Eng. Waddah Attar |
//|                                          waddahattar@hotmail.com |
//+------------------------------------------------------------------+
//----
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Lime
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Brown
//----
extern int RSIPeriod1=14;
extern int RSIPeriod2=28;

double   up_buffer1[];
double   up_buffer2[];
double   dn_buffer1[];
double   dn_buffer2[];
double   ind_buffer1[];
double   ind_buffer2[];
double   MABuffer1[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID, 2);
//----   
   SetIndexBuffer(0, up_buffer1);
   SetIndexBuffer(1, up_buffer2);
   SetIndexBuffer(2, dn_buffer1);
   SetIndexBuffer(3, dn_buffer2);
   SetIndexBuffer(4, ind_buffer1);
   SetIndexBuffer(5, MABuffer1);
   SetIndexBuffer(6, ind_buffer2);
//----   
   IndicatorShortName("OsWAD RSI ("+RSIPeriod1+","+RSIPeriod2+") ");
    SetIndexLabel ( 0, "" );
    SetIndexLabel ( 1, "" );
    SetIndexLabel ( 2, "" );
    SetIndexLabel ( 3, "" );
    
    return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double RSI1,RSI2,Explo;

   int  limit, i, counted_bars = IndicatorCounted();
//----
   if(counted_bars < 0) 
       return(-1);
//----
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
//----
   for(i = limit; i >= 0; i--)
   {
     RSI1 = iRSI(NULL, 0, RSIPeriod1, PRICE_CLOSE, i);
     RSI2 = iRSI(NULL, 0, RSIPeriod2, PRICE_CLOSE, i);

     MABuffer1[i] = (RSI1-RSI2);
   }

   for(i = 0; i <= limit; i++)
   {
     ind_buffer1[i] = iMAOnArray(MABuffer1,0,14,0,MODE_SMA,i);
   }
   for(i = 0; i <= limit; i++)
     ind_buffer2[i]=MABuffer1[i]-ind_buffer1[i];
   for(i = 0; i <= limit; i++)
   {
     if(ind_buffer2[i]>0)
     {
        dn_buffer1[i]=0;
        dn_buffer2[i]=0;
        if(ind_buffer2[i]>ind_buffer2[i+1])
        {
           up_buffer1[i]=ind_buffer2[i];
           up_buffer2[i]=0;
        }
        else
        {
           up_buffer1[i]=0;
           up_buffer2[i]=ind_buffer2[i];
        }
     }
     else
     {
        up_buffer1[i]=0;
        up_buffer2[i]=0;
        if(ind_buffer2[i]<ind_buffer2[i+1])
        {
           dn_buffer1[i]=ind_buffer2[i];
           dn_buffer2[i]=0;
        }
        else
        {
           dn_buffer1[i]=0;
           dn_buffer2[i]=ind_buffer2[i];
        }
     }
   }
   return(0);
}
//+------------------------------------------------------------------+


